#include	"main.h"




//////////////////
Program*
	StartProgram	(
					char*	PrgName
					)
	{
	void*		pBuff;
	Program*	pPrg;
	int			parseRez;

	try
		{
		pPrg = NewProgram(PrgName);
		pBuff = AllocBuffer(PrgName);
		PushBuffer(pBuff);
		}
	catch(ExceptionProgramNotFound* E)
		{
		E->dummy();
		return (Program*)NULL;
		}
	catch(ExceptionCallMaxDeepExceed* E)
		{
		E->dummy();
		free(pBuff);
		return (Program*)NULL;
		}

	pCurrentProgram = pPrg;
	OutputMsg("-------Parse program: \"%s\"-------\n",pPrg->strPrgName);
	parseRez = yyparse((void*)pPrg);
	FreeBuffer(PopBuffer());
	return parseRez ? (Program*)NULL : pPrg;
	}


#ifdef	ACTIVEX_DLL
///////////////
int
	RunProgram	( BSTR In , BSTR* Out)
	{
	Program*	pPrg;

	InitBuffers();
	strOut = CString("");
	strTemp = CString("");

	pPrg = StartProgram((char*)_bstr_t(In,FALSE));

	if ( pPrg )
		{
		OutputMsg("----------Begin execution----------\n");
		ExecuteProgram(pPrg);
		OutputMsg("----------End execution------------\n");
		OutputMsg("----------Freeing resources--------\n");
		FreeProgram(pPrg);
		OutputMsg("----------End process--------------\n");
		}


	DoneBuffers();


	int			i,j;
	OutputMsg("");
	j = strOut.GetLength();
	for ( i=0 ; i<j ; i++)
		if (strOut[i]==10)
			if ( i==0 || strOut[i-1]!=13)
				{
				strOut.Insert(i,13);
				j++;i++;
				}
	j = strOut.GetLength();

	if (j>0x8000)
		{
		strOut.Empty();
		strOut.Format("Rezultatul nu poate fi afisat (mai mare de %d octeti)",0x8000);
		}

	*Out = strOut.AllocSysString();
	strOut.Empty();
	return 0;
	}

#endif



#ifdef EXE_PROGRAM
int
	main	(
			int			argc,
			char*		argv[]
			)
	{
	Program*	pPrg;

	if (argc!=2)
		{
		OutputMsg("Please type: Calculator ProgramName");
		return 1;
		}

	InitBuffers();

	pPrg = StartProgram(argv[1]);

	if ( pPrg )
		{
		OutputMsg("----------Begin execution----------\n");
		ExecuteProgram(pPrg);
		OutputMsg("----------End execution------------\n");
		OutputMsg("----------Freeing resources--------\n");
		FreeProgram(pPrg);
		OutputMsg("----------End process--------------\n");
		}

	DoneBuffers();
	return 0;
	}
#endif
