#ifndef		BUFFERS_H
#define		BUFFERS_H


/**************************************************************
*
*	Fisiere header
*
**************************************************************/
#include	"main.h"



/**************************************************************
*
*	Declaratii de functii
*
**************************************************************/
// Initializeaza modulul
void
	InitBuffers ( void );
// Finalizeaza modulul
void
	DoneBuffers ( void );

// cauta in baza de date programul "strNumeProg" si declanseaza scanarea
// intoarce pointer catre buffer
void*
	AllocBuffer	(
				char*	 strNumeProg
				);

// Elibereaza memoria alocata pentru buffer
void
	FreeBuffer	(
				void*	 pProgramBuffer
				);

// Comuta buffer-ul pentru lex
void
	PushBuffer	(
				void*	 pProgramBuffer
				);

// Comuta buffer-ul pentru lex
void*
	PopBuffer	( void );














#endif
